/* 
	V1.3
	v_1.01 (16.09.18) TEST
	19.09.18 - ogranich L_imp
	V1.1 - 24.09.18 scale ...many diffrent
	V1.2 - rename,Limp
	V1.3 - invert_dir
		COMBO

*/

#include "rtapi_ctype.h"		/* isspace() */
#include "rtapi.h"		/* RTAPI realtime OS API */
#include "rtapi_app.h"		/* RTAPI realtime module decls */
#include "hal.h"			/* HAL public API decls */
#include <linux/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "etcomb.h"


#define Glob_out_byte 1
#define lock_out_byte 2
#define index_en_byte 3
#define CONTRl_byte 4

#define Max_pause 16777215

/* module information */
MODULE_AUTHOR("");
MODULE_DESCRIPTION("");
MODULE_LICENSE("GPL");


/***********************************************************************
*                STRUCTURES AND GLOBAL VARIABLES                       *
************************************************************************/
static char *board_ip;
RTAPI_MP_ARRAY_STRING(board_ip, 1, "ip address of ethernet board");

static data_t *device_data;

/* other globals */
static int comp_id;		/* component ID */
static int num_ports;		/* number of ports configured */

int WD_start =0;
int eede=0;


/***********************************************************************
*                  LOCAL FUNCTION DECLARATIONS                         *
************************************************************************/
/* These is the functions that actually do the I/O
   everything else is just init code
*/
static void update_port(void *arg, long period);
static int eth_socket_send(int sockfd, const void *buffer, int len, int flags);
static int eth_socket_recv(int sockfd, void *buffer, int len, int flags);


/***********************************************************************
*                       INIT AND EXIT CODE                             *
************************************************************************/

int rtapi_app_main(void)
{
    char name[HAL_NAME_LEN + 1];
    int retval,n,i,r ;
    
    num_ports = 1;
    n = 0;

    
    /* STEP 1: initialise the driver */
    comp_id = hal_init(driver_NAME);
    if (comp_id < 0) {
    	rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: hal_init() failed\n"); 
    	return -1;
    }


    /* STEP 2: allocate shared memory for to_hal data */
    device_data = hal_malloc(num_ports * sizeof(data_t));
    if (device_data == 0) {
    	rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: hal_malloc() failed\n");
		r = -1;
		goto fail0;    
    }

//###################################################
///// INIT ETH BOARD ; OPEN SOCKET
//###################################################

	device_data->sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(device_data->sock < 0)
	{
		rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR_socket\n");;
		goto fail0;
	}

	device_data->addr.sin_family = AF_INET;
	device_data->addr.sin_port = htons(UDP_PORT);
	device_data->addr.sin_addr.s_addr = inet_addr(board_ip);

	retval = connect(device_data->sock, (struct sockaddr *)&device_data->addr, sizeof(device_data->addr));
    if (retval < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR_connect\n");
        goto fail1;
    }

	struct timeval timeout;
	timeout.tv_sec = 0;
	timeout.tv_usec = SEND_TIMEOUT_US;
    retval = setsockopt(device_data->sock, SOL_SOCKET, SO_SNDTIMEO, (char *)&timeout, sizeof(timeout));
	if (retval < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: NOT set setsockopt for tx\n");
        goto fail1;
    }

	timeout.tv_usec = 10000; //FIRST_PACKETS
	retval = setsockopt(device_data->sock, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(timeout));
	if (retval < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: NOT set setsockopt for first rx\n");
        goto fail1;
    }
		//need clear data packet !!!!!!!!!!!!!!! 
			// FIRST packet send (long time)
	device_data->read_pack[0] = Big_pack_new;// ident
	device_data->read_pack[CONTRl_byte] = 0x00;// reset WD


	retval = eth_socket_send(device_data->sock, &device_data->read_pack, 35,0);
	if (retval < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: NOT send firs packet\n");
        goto fail1;
    }

	// identification board pwm or sd
	device_data->SD_board_num = 0;
	device_data->PWM_board_num = 0;

	retval = eth_socket_recv(device_data->sock, &device_data->read_pack, sizeof(device_data->read_pack), 0);

	if(device_data->read_pack[0] == SD_board_iden){
		 device_data->SD_board_num = 1;
	}
	else
		if(device_data->read_pack[0] == PWM_board_iden)
			device_data->PWM_board_num = 1;
		else 	{
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: NOT support board\n");
        		goto fail1;
	
		}
	//device_data->SD_board_num = 1;device_data->PWM_board_num = 0;
	//if(device_data->read_pack[0] == PWM_board_iden){device_data->PWM_board_num = 1;device_data->SD_board_num = 0;}
		


	timeout.tv_usec = RECV_TIMEOUT_US;
	retval = setsockopt(device_data->sock, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(timeout));
	if (retval < 0) {
        rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: NOT set setsockopt for rx\n");
        goto fail1;
    }


  	device_data->first_run = 1;
	device_data->block = 0; //local block
//######################################################
//######### EXPORT SIGNALS, PIN, FUNCTION
//######################################################

//////////////////////
//////////////////////
//////////////////////
/* Export IO pin's */

//########################## INPUTS ###############################
    /* export write only HAL pin's for the input bit */
    for ( i=0; i<=15;i++) {
		retval = hal_pin_bit_newf(HAL_OUT, &(device_data->digital_in[i]),comp_id, "etcomb.%d.pins.pin-%02d-in", 1, i);
      	if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR, "etcomb: ERROR: port %d var export failed with err=%i\n", i + 1,retval);
			r = -1;
			goto fail1;
		}
      
      	retval = hal_pin_bit_newf(HAL_OUT, &(device_data->digital_in_n[i]),comp_id, "etcomb.%d.pins.pin-%02d-in-n", 1, i);
      	if (retval < 0) {
        	rtapi_print_msg(RTAPI_MSG_ERR, "etcomb: ERROR: port %d var export failed with err=%i\n", i + 1,retval);
        	r = -1;
        	goto fail1;
      	}
      
    }
    
        /* export write only HAL pin's for the input bit */
    for ( i=0; i<=3;i++) {
		retval = hal_pin_bit_newf(HAL_OUT, &(device_data->digital_lin[i]),comp_id, "etcomb.%d.Lpins.pin-%02d-in", 1, i);
      	if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR, "etcomb: ERROR: port %d var export failed with err=%i\n", i + 1,retval);
			r = -1;
			goto fail1;
		}
      
      	retval = hal_pin_bit_newf(HAL_OUT, &(device_data->digital_lin_n[i]),comp_id, "etcomb.%d.Lpins.pin-%02d-in-n", 1, i);
      	if (retval < 0) {
        	rtapi_print_msg(RTAPI_MSG_ERR, "etcomb: ERROR: port %d var export failed with err=%i\n", i + 1,retval);
        	r = -1;
        	goto fail1;
      	}
      
    }
    
    
//########################## OUTPUTS ###############################    
    /* export read only HAL pin's for the output bit */
    for ( i=0; i<=7;i++) {
		retval = hal_pin_bit_newf(HAL_IN, &(device_data->digital_out[i]),comp_id, "etcomb.%d.pins.pin-%02d-out", 1, i);

		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: port %d var export failed with err=%i\n", i + 1,retval);
			r = -1;
			goto fail1;
		}
    }
    
     for ( i=0; i<=1;i++) {
		retval = hal_pin_bit_newf(HAL_IN, &(device_data->digital_lout[i]),comp_id, "etcomb.%d.Lpins.pin-%02d-out", 1, i);

		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: port %d var export failed with err=%i\n", i + 1,retval);
			r = -1;
			goto fail1;
		}
    }


///////////////////////////
///////////////////////////
///////////////////////////
/* export read only HAL pin's for the control bit */

	retval = hal_pin_bit_newf(HAL_IN, &(device_data->enable_dr),comp_id, "etcomb.%d.enable_drive", 1);

	if (retval < 0) {
		rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: enable_dr var export failed with err=%i\n",retval);
		r = -1;
		goto fail1;
	}

	retval = hal_pin_bit_newf(HAL_OUT, &(device_data->WD_lock),comp_id, "etcomb.%d.WD_lock", 1);

	if (retval < 0) {
		rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: enable_dr var export failed with err=%i\n",retval);
		r = -1;
		goto fail1;
	}

/////////////////////////////
/////////////////////////////
/////////////////////////////
/* export encoder signal */

	for ( i=0; i<=(NUM_chanal-1);i++) {
		/* encoder_count */
		retval = hal_pin_float_newf(HAL_OUT, &(device_data-> enccounts[i]), comp_id, "etcomb.%d.feedback.encoder%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err encoder=%i\n", retval);
			r = -1;
			goto fail1;
		}
				/* encoder_scale */
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> encscale[i]), comp_id, "etcomb.%d.feedback.enc_scale%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err enc_scale=%i\n", retval);
			r = -1;
			goto fail1;
		}
		*device_data-> encscale[i] = 1;

				/* index */
		retval = hal_pin_bit_newf(HAL_IO, &(device_data->index_en[i]),comp_id, "etcomb.%d.feedback.index_en%01d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: port %d var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1; 
		}  
			/* encoder_velocity */
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> encvel[i]), comp_id, "etcomb.%d.feedback.enc_vel%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err enc_velocity=%i\n", retval);
			r = -1;
			goto fail1;
		}   
	}
	

	if(device_data->SD_board_num == 1){
//////////////////////////////
/////////////////////////////
/////////////////////////////
/* export control drive PWM*/


		retval = hal_pin_float_newf(HAL_IN, &(device_data-> dcontrol[0]), comp_id, "etcomb.%d.PWM.dcontrol", 1);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err dcontrol=%i\n", retval);
			r = -1;
			goto fail1;
		}

		retval = hal_pin_float_newf(HAL_IN, &(device_data-> outscale[0]), comp_id, "etcomb.%d.PWM.out_scale", 1);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err out_scale=%i\n", retval);
			r = -1;
			goto fail1;
		}

//////////////////////////////
/////////////////////////////
/////////////////////////////
	/* export control drive STEP_DIR*/

	for ( i=0; i<=(Max_sdchanel-1);i++) {
			/* out signals step/dir */
		retval = hal_pin_float_newf(HAL_IN, &(device_data->digital_out_step[i]),comp_id, "etcomb.%d.step_dir.outstep%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err out_step=%i\n", retval);
			r = -1;
			goto fail1;
		}
			/* feed back step/dir */
		retval = hal_pin_float_newf(HAL_OUT, &(device_data-> sd_counts[i]), comp_id, "etcomb.%d.step_dir.count%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err encoder=%i\n", retval);
			r = -1;
			goto fail1;
		}
			/* DIRC step/dir */
		retval = hal_pin_bit_newf(HAL_IN, &(device_data->invert_dir[i]), comp_id, "etcomb.%d.step_dir.invert_dir%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err invert_dir=%i\n", retval);
			r = -1;
			goto fail1;
		}
		*device_data->invert_dir[i] = 0;

			/* scale step/dir */
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> sdscale[i]), comp_id, "etcomb.%d.step_dir.escale%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err scale=%i\n", retval);
			r = -1;
			goto fail1;
		}
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> Limp[i]), comp_id, "etcomb.%d.step_dir.Limp%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err Limp=%i\n", retval);
			r = -1;
			goto fail1;
		}

		*device_data-> sdscale[i] = 1;
	}
}
	else if(device_data->PWM_board_num == 1)
{

	/////////////////////////////
	/* export control drive PWM*/


	for ( i=0; i<=(NUM_chanal-1);i++) {
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> dcontrol[i]), comp_id, "etcomb.%d.PWM.dcontrol%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err dcontrol=%i\n", retval);
			r = -1;
			goto fail1;
		}

		retval = hal_pin_float_newf(HAL_IN, &(device_data-> outscale[i]), comp_id, "etcomb.%d.PWM.out_scale%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR:  err out_scale=%i\n", retval);
			r = -1;
			goto fail1;
		}
	}

}

//////////////////////////////
/////////////////////////////
/////////////////////////////
// Export TESTS signls


	retval = hal_pin_u32_newf(HAL_OUT, &(device_data->test),comp_id, "etcomb.%d.TEST", 1);
      	if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR, "etcomb: ERR: port %d TEST var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1;
		}
	retval = hal_pin_u32_newf(HAL_OUT, &(device_data->testi),comp_id, "etcomb.%d.TEST_INT", 1);
      	if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR, "etcomb: ERR: port %d TEST var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1;
		}

	*device_data->testi = 0;

////////////////////////////////////////
//// UPDATE  export function
////////////////////////////////////////

    /* STEP 4: export function */
    rtapi_snprintf(name, sizeof(name), "etcomb.%d.update", n + 1);
    retval = hal_export_funct(name, update_port, device_data, 1, 0,comp_id);
    if (retval < 0) {
		rtapi_print_msg(RTAPI_MSG_ERR,"etcomb: ERROR: port %d write funct export failed\n", n + 1);
		r = -1;
		goto fail1;
    }


    rtapi_print_msg(RTAPI_MSG_INFO,"etcomb: installed driver for %d card(s)\n", num_ports);
    hal_ready(comp_id);
    return 0;


//####### ERROR ############

fail1:
close(device_data->sock);

fail0:
hal_exit(comp_id);
return r;

}
//####### EXIT ############
void rtapi_app_exit(void)
{	
	close(device_data->sock);
	hal_exit(comp_id);
	//printk(KERN_ALERT "to_pci: exit\n");
}



//###########################################################################################################
//
//			FUNCTIONS
//
//###########################################################################################################

static int eth_socket_send(int sockfd, const void *buffer, int len, int flags) {
    return send(sockfd, buffer, len, flags);
}

static int eth_socket_recv(int sockfd, void *buffer, int len, int flags) {
    return recv(sockfd, buffer, len, flags);
}

///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///    STEP DIR FUNCTIONS
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////

__s32 DDcontr(void *farg,__u8 exr)
{
// Ti = 1000ns
// Tots = 20ns
// Ti_ots = Ti/Tots;
#define L_imp 2
#define Ti_ots 50

	data_t *data_sd;

	__u8 ttz;
	__u32 temp,pack,pause_up;
	float V_cmd;
	__u32  L_N_imp;

	data_sd = farg;

	V_cmd = *(data_sd-> digital_out_step[exr]);
	
	//limp
	L_N_imp = (__u32)*(data_sd-> Limp[exr]) * 2;
	L_N_imp = L_N_imp & 0x0000000F;
	if(L_N_imp == 0) L_N_imp = 4;

	//Направление	

	pack = 0;		//установка dir(в переменной pack будем собирать посылку)
	if(V_cmd<0) 
	{
    		pack=1;	      //установка dir
    		V_cmd = -V_cmd; //модуль скорости
  	}
	//inverse
	if(*data_sd-> invert_dir[exr])
	pack = pack ^ 0x00000001;



 	//Ограничение Vin
	if(V_cmd >10) V_cmd = 10;

	ttz = 0x01; // Флаг разрешения выдачи STEP
	if(V_cmd != 0)

		pause_up = (__u32)((10/V_cmd)*(Ti_ots*L_imp + 1));

	else
		{
			pause_up = Max_pause;
			ttz = 0;
		}

  	if(pause_up > Max_pause)
		{
			pause_up = Max_pause;
			ttz = 0;
		}

	//enable
  	pack <<= 1;
	pack = pack | ttz;

	//pouse
	pack <<= 30;
	temp = pause_up & 0x00ffffff;
	pack = pack | temp;

	if(ttz) data_sd->last_pause[exr] = pack & 0x80FFFFFF;

	//limp
	L_N_imp <<= 24;
	pack = pack | L_N_imp;

	return pack;
}


/**************************************************************
###############################################################
* REALTIME PORT WRITE FUNCTION                                *
###############################################################
**************************************************************/

void update_port(void *arg, long period){
	data_t *port;
	__u8 i,k;
	int recv,retval;
	__u8 buff_send[40];
	__u8 tmp,tmp1,tmp2,tmp3,lastdir;
	__s32 ikor;
	__s32 tmp32,tmp32A,tmp32B,ll_pause[Max_sdchanel];

	float tmpfloat,_tmpfloat;

	port = arg;
	//pack_mainR_t *rcv_data_main = (void*)port->read_pack;
	//pack_mainW_t *snd = ((void*)buff_send);


	for ( i=0; i < Max_sdchanel;i++) 
	{
	ll_pause[i] = port -> last_pause[i];
	}

	// #################  send request ######################
	buff_send[0] = Big_pack_new;

////////////////	CONTROL    ////////////////////////////////////////////
	if(port->SD_board_num == 1){

		k = 6;
			//PWM
		ikor = (*port->outscale[0])*((*(port-> dcontrol[0]))/10)*0xffff;	
	    	tmp32 = ikor;
	    	tmp32 = tmp32 >> 4;
	    	tmp1 = tmp32;
	    	tmp32 = tmp32 >> 8;
	    	tmp2 = tmp32 & 0x0F;
	    	tmp32 = tmp32 >> 15;
	    	tmp3 = tmp32;
	   	 tmp2 = tmp2 | (tmp3 & 0x10);
	   	 buff_send[k] = tmp1;
	    	k++;
	    	buff_send[k] = tmp2;
	    	k++; 

		// SD ############################################

		for ( i=0; i<=(Max_sdchanel-1);i++) {
		    	tmp32 = DDcontr(port,i);
		    	tmp1 = tmp32;
				buff_send[k] = tmp1;
		    	k++;
				if(!i) *port->test = tmp32 & 0x00FFFFFF;
		
		
		    	tmp32 = tmp32 >> 8;
				tmp1 = tmp32;
				buff_send[k] = tmp1;
		    	k++;
		
				tmp32 = tmp32 >> 8;
				tmp1 = tmp32;
				buff_send[k] = tmp1;
		    	k++;
		
				tmp32 = tmp32 >> 8;
				tmp1 = tmp32;
				buff_send[k] = tmp1;
		    	k++;
		} 
	}
	else {

		k = 6;
		for ( i=0; i<=(NUM_chanal-1);i++) {
			ikor = (*port->outscale[i])*((*(port-> dcontrol[i]))/10)*0xffff;	
    			tmp32 = ikor;
    			tmp32 = tmp32 >> 4;
    			tmp1 = tmp32;
    			tmp32 = tmp32 >> 8;
    			tmp2 = tmp32 & 0x0F;
    			tmp32 = tmp32 >> 15;
    			tmp3 = tmp32;
    			tmp2 = tmp2 | (tmp3 & 0x10);
    			buff_send[k] = tmp1;
    			k++;
    			buff_send[k] = tmp2;
    			k++;
		} 
	}

////////////////  END	CONTROL    ////////////////////////////////////////////

	// write Glob digital outputs 
    tmp1 = 0;
    tmp2 = 0x01;
    for (i=0; i < 8; i++) {
		if (*port->digital_out[i]) {
			tmp1 |= tmp2;
		}
		tmp2 <<= 1;
	}
	buff_send[Glob_out_byte] = tmp1;



	// write Lock digital outputs
	tmp1 = 0;
	tmp2 = 0x01;
	for (i=0; i < 2; i++) {
		if (*port->digital_lout[i]) {
			tmp1 |= tmp2;
		}
		tmp2 <<= 1;
	}
	buff_send[lock_out_byte] = tmp1;
          
	// write index_enable outputs 
	tmp1 = 0;
	tmp2 = 0x01;
	for (i=0; i < 5; i++) {
		if (*port->index_en[i]) {
			tmp1 |= tmp2;
		}
		tmp2 <<= 1;
	}
	buff_send[index_en_byte] = tmp1;
          
  // control
	tmp1 = 0;
	tmp2 = 0;
	tmp3 = 0;
	if(*port->enable_dr) tmp1 = 0x10;
	if(port->first_run) {tmp2 = 0x80;port->first_run=0;}
	if(port->block != 0) tmp3 = 0; else tmp3 = 0x08;
	
	buff_send[CONTRl_byte] = tmp1 | tmp2 | tmp3;// control

	//other
	buff_send[5] = 0xDD;// data reg

			/////TRANSMIT////
	retval = eth_socket_send(port->sock,buff_send,35,0);
    ///// error working




// #################  RECIVE DATA  ###############################################################
// #################  RECIVE DATA  ###############################################################
				//start recive process
	i=0;
	do {
        recv = eth_socket_recv(port->sock, &port->read_pack, sizeof(port->read_pack), 0);
		i++;
    } while ((recv < 0) && (i < 3));
    
  	if (i==3 && (recv < 0)) {
    	buff_send[0] = Lit_pack_old;
    	retval = eth_socket_send(port->sock,buff_send,35,0);
    	do {
        	recv = eth_socket_recv(port->sock, &port->read_pack, sizeof(port->read_pack), 0);
			i++;
    	} while ((recv < 0) && (i < 6));
  	}
				//end recive process
			
	if((recv < 0) || (i == 6)) port->block = 0xFF;
	if(*port->testi < i) *port->testi = i;

	if(port->block == 0) *port->WD_lock = 0; else *port->WD_lock = 1;

	//parse recive data
	if(recv>0)
		
		if(port->read_pack[0] == SD_board_iden || port->read_pack[0] == PWM_board_iden){
      ///////////// read encoders /////////////////////////////////////////////

     		k = 1;
      		for ( i=0; i<=4;i++) {
        		tmp32A = 0;
        		tmp32A |= port->read_pack[k];
        		k++;
        		tmp32A <<= 8;
        		tmp32A |= port->read_pack[k];
        		k++;
        		tmp32A <<= 8;
        		tmp32A |= port->read_pack[k];
        		k++;
        		tmp32A <<= 8;
        		tmp32A |= port->read_pack[k];
        		k++;

        		*port->enccounts[i] = tmp32A/(*port->encscale[i]);

        		tmp32B = tmp32A - (port->enc_lv[i]);
        		port->enc_lv[i] = tmp32A;
        		tmp32B = tmp32B*1000;

        		*port->encvel[i] = tmp32B/(*port->encscale[i]);
      		}
		
      		// Index....
      		tmp1 = port->read_pack[25];
      		tmp2 = 0x01;
      		for (i=0; i < 5; i++) {
        		if(*port->index_en[i] && (tmp1 & tmp2)){
          			*port->index_en[i] = 0;
        		}
       			tmp2 <<= 1;
      		}
		
      		// read digital inputs 	    
      		tmp1 = port->read_pack[26]; 
      		tmp3 = port->read_pack[27];
      		tmp2 = 0x01;
      		for (i=0 ; i < 8 ; i++) {
        		*(port->digital_in[i]) = (tmp1 & tmp2) ? 1:0 ;
        		*(port->digital_in_n[i]) = (tmp1 & tmp2) ? 0:1 ;
        
        		*(port->digital_in[i+8]) = (tmp3 & tmp2) ? 1:0 ;
        		*(port->digital_in_n[i+8]) = (tmp3 & tmp2) ? 0:1 ;
        		tmp2 <<= 1;
      		}
      
      		tmp1 = port->read_pack[28]; 
      		tmp2 = 0x01;
      		for (i=0 ; i < 4 ; i++) {
        		*(port->digital_lin[i]) = (tmp1 & tmp2) ? 1:0 ;
        		*(port->digital_lin_n[i]) = (tmp1 & tmp2) ? 0:1 ;
        		tmp2 <<= 1;
      		}

			//*port->test = port->read_pack[29];	

//////////////////////////////////////////////////////////////////////////////	
////////////////////STEP dir section///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

///////////// read s/d count /////////////////////////////////////////////
	if(port->SD_board_num == 1){
		k = 30;
	
		for ( i=0; i<=(Max_sdchanel-1);i++) 
		{
			k = k + 3;
	
			tmp32 = port->read_pack[k];
	
			tmp32 = tmp32 << 8;
			k = k - 1;
			tmp32 |= port->read_pack[k];
	
			tmp32 = tmp32 << 8;
			k = k - 1;
			tmp32 |= port->read_pack[k];
	
			tmp32 = tmp32 << 8;
			k = k - 1;
			tmp32 |= port->read_pack[k];
	
			k = k + 23;
			// считываем значение счётчика паузы
			tmp32A = port->read_pack[k];
	
			tmp32A = tmp32A << 8;
			k = k - 1;
			tmp32A |= port->read_pack[k];
	
			tmp32A = tmp32A << 8;
			k = k - 1;
			tmp32A |= port->read_pack[k];
	
			tmp32A = tmp32A << 8;
			k = k - 1;
			tmp32A |= port->read_pack[k];
			k = k - 16;
	
			//tmp32 - значение счётчика COUNT,  tmp32A - значение счётчика паузы & control byte
			lastdir = 0;
			if(tmp32A & 0x01000000)lastdir = 1;
			tmp32A &= 0x00FFFFFF;
	
			// пердыдущее значение счётчика паузы
			tmp32B = ll_pause[i];
 			tmp32B &= 0x00FFFFFF;
			if(tmp32B == 0) tmp32B = 0x00FFFFFF;
	
			//находим дробную часть количества импульсов
			_tmpfloat =(float) tmp32A/tmp32B;
	
			if(_tmpfloat > 1) _tmpfloat = 0;
			
			if (lastdir) tmpfloat = 1-_tmpfloat;
			else tmpfloat = _tmpfloat;
	
			*port->sd_counts[i] = (tmp32 + tmpfloat)/(*port->sdscale[i]);

		}
	}
	}
}

