


//#define UDP_PORT 8484 //for 192.168.1.70 - io
//#define UDP_PORT 1111 //for 192.168.1.3 - main
#define SD_board_iden  0x03
#define PWM_board_iden 0x05

#define UDP_PORT 1111
#define SEND_TIMEOUT_US 10
#define RECV_TIMEOUT_US 10
#define READ_PCK_DELAY_NS 10000
#define driver_NAME "etcomb"

#define Lit_pack_new 0xAB
#define Lit_pack_old 0xCB
#define Big_pack_new 0xBB

#define Max_sdchanel 5
#define NUM_chanal 6

char msg[] = "Hello there!\n";

// structura driver data

typedef struct {
	int sock;
	struct sockaddr_in addr;
	__u8 read_pack[1400];
	__u8 first_run;
	__u8 block;
	__u8 SD_board_num;
	__u8 PWM_board_num;
	//tests signals
	hal_u32_t *test;
	hal_u32_t *testi;
	
	// hal work signals
  	hal_bit_t *digital_in[16];    /* ptrs for digital input pins 16 */
	hal_bit_t *digital_in_n[16];
  	hal_bit_t *digital_out[8];    /* ptrs for digital output pins 8 */
  
  	hal_bit_t *digital_lin[4];    /* ptrs for digital input pins 4 */
	hal_bit_t *digital_lin_n[4];
  	hal_bit_t *digital_lout[2];    /* ptrs for digital output pins 2 */
  
	hal_bit_t *enable_dr; 

	hal_bit_t *index_en[NUM_chanal];
	hal_float_t *enccounts[NUM_chanal];
	hal_float_t *encscale[NUM_chanal];
	hal_float_t *encvel[NUM_chanal];

	hal_float_t *outscale[NUM_chanal];
	hal_float_t *dcontrol[NUM_chanal];

	hal_float_t *sdscale[Max_sdchanel];
	hal_float_t *digital_out_step[Max_sdchanel];
	hal_float_t *sd_counts[Max_sdchanel];
	hal_bit_t *invert_dir[Max_sdchanel];
	hal_float_t *Limp[Max_sdchanel];
	__u32 last_pause[Max_sdchanel];
	

	hal_bit_t *WD_lock;

	__s32 enc_lv[NUM_chanal];

} data_t;

// structura packets data for MAIN board

typedef struct {
	__u8 ident;
	__u32 enc0;
	__u32 enc1;
	__u32 enc2;
	__u32 enc3;
	__u32 enc4;
	__u32 enc5;
	__u8 enc_zero;//wd_lock[7]  ([25])
	__u8 input_b0;
	__u8 input_b1;
	__u8 ffwork;//flag_work[7],lock_inp[3:0]
	__u8 data_byte;//([29])
	__u32 SD_FB0;//[7:0][15:8][23:16][31:24]
	__u32 SD_FB1;
	__u32 SD_FB2;
	__u32 SD_FB3;
	__u32 SD_FB4;
	__u32 wpause0;//[7:0][15:8][23:16][6'b0,25,24]
	__u32 wpause1;
	__u32 wpause2;
	__u32 wpause3;
	__u32 wpause4;
	
} pack_mainR_t;

typedef struct {
	__u8 ident;
	__u8 Gout_pin;//[7:0]
	__u8 Lout_pin;//[1:0]
	__u8 index;//[4:0]
	__u8 contrl_dat;//res_wd[7],dr_en[4],ext_wd[3],spi_en[0]    
	__u8 data_byte;
	__u16 pwm_out0;
	__u32 SD_data0;
	__u32 SD_data1;
	__u32 SD_data2;
	__u32 SD_data3;
	__u32 SD_data4;

} pack_mainW_t;


